unit u_05_iw_edit_dbgrid_ado;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, DB, Controls,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWGrids,
  IWDBGrids, IWCompLabel, IWDBStdCtrls, IWCompButton, IWCompMemo, IWCompEdit;

type
  TIWForm1 = class(TIWAppForm)
    DataSource1: TDataSource;
    IWDBGrid1: TIWDBGrid;
    previous1: TIWButton;
    IWLabel1: TIWLabel;
    IWMemo1: TIWMemo;
    next1: TIWButton;
    procedure next1Click(Sender: TObject);
    procedure previous1Click(Sender: TObject);
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWDBGrid1RenderCell(ACell: TIWGridCell; const ARow,
      AColumn: Integer);
  public
    m_c_do_modify_button_list: array of tIwButton;
    m_c_do_post_button, m_c_do_cancel_button: tIwButton;

    // m_c_key_list: array of String;
    m_c_edit_list: array of tIwEdit;

    m_do_modify: Boolean;
    m_selected_row: Integer;
    m_selected_key: String;

    procedure handle_do_modify_click(Sender: tObject);
    procedure handle_do_cancel_click(Sender: TObject);
    procedure handle_do_post_click(Sender: TObject);
    procedure display(p_text: String);
    procedure clear_display;
  end;

implementation
  uses UserSessionUnit_5, ServerController_5;

{$R *.dfm}


    procedure TIWForm1.display(p_text: String);
      begin
        IwMemo1.Lines.Add(p_text);
      end; // display

    procedure TIWForm1.clear_display;
      begin
        IwMemo1.Lines.Clear;
      end; // clear_display

    const k_table_column_count= 2;

    procedure TIWForm1.IWAppFormCreate(Sender: TObject);
      var l_row_index: Integer;
          l_c_do_modify_button: tIwButton;
          l_column_index: Integer;
          l_c_iwedit: tIwEdit;
      begin
        SetLength(m_c_do_modify_button_list, IwDbGrid1.RowLimit);

        for l_row_index:= 0 to IwDbGrid1.RowLimit- 1 do
        begin
          l_c_do_modify_button:= tIwButton.Create(Self);
          with l_c_do_modify_button do
          begin
            Caption:= 'Modify_'+ IntToStr(l_row_index);
            // -- offset by 1 because of the row header
            Tag:= l_row_index+ 1;
            Width:= 60;
            // DoSubmitValidation:= True;
            OnClick:= handle_do_modify_click;
          end; // with l_iwbutton

          m_c_do_modify_button_list[l_row_index]:= l_c_do_modify_button;
          // IwDbGrid1.Columns[0].Control:= l_iwButton;
        end; // for l_row_index

        // SetLength(m_c_key_list, IwDbGrid1.RowLimit);

        SetLength(m_c_edit_list, k_table_column_count);
        for l_column_index:= 0 to k_table_column_count- 1 do
        begin
          l_c_iwedit:= tIwEdit.Create(Self);
          with l_c_iwedit do
          begin
            Text:= 'Edit_'+ IntToStr(l_column_index);
            Width:= 60;
          end;
          m_c_edit_list[l_column_index]:= l_c_iwedit;
        end; // for l_column_index

        m_c_do_post_button:= tIwButton.Create(Self);
        with m_c_do_post_button do
        begin
          Color:= clWebLime;
          Caption:= 'Post';
          Width:= 35;
          Visible:= False;
          OnClick:= handle_do_post_click;
        end; // with m_c_do_post_button

        m_c_do_cancel_button:= tIwButton.Create(Self);
        with m_c_do_cancel_button do
        begin
          Color:= clWebRed;
          Caption:= 'Cancel';
          Width:= 50;
          Visible:= False;
          OnClick:= handle_do_cancel_click;
        end; // with m_c_do_cancel_button
      end; // IWAppFormCreate

    procedure TIWForm1.previous1Click(Sender: TObject);
      begin
        UserSession.AdoDataset1.MoveBy(-IwDbGrid1.RowLimit);
      end; // previous1Click

    procedure TIWForm1.next1Click(Sender: TObject);
      begin
        UserSession.AdoDataset1.MoveBy(IwDbGrid1.RowLimit);
      end; // next1Click

    procedure TIWForm1.IWDBGrid1RenderCell(ACell: TIWGridCell; const ARow,
        AColumn: Integer);

      procedure display_column_title;
        begin
          case AColumn of
            0 : Acell.Text:= 'modify ?';
            1 : Acell.Text:= 'Name';
            2 : Acell.Text:= 'Population';
            3 : Acell.Text:= 'Post';
            4 : Acell.Text:= 'Cancel';
          end; // case AColumn
        end; // display_column_title

      procedure draw_in_display_mode;
        var l_field_value: String;
        begin
          if ARow= 0
            then display_column_title
            else
              case AColumn of
                0 : begin
                      // -- the button column
                      ACell.Control:= m_c_do_modify_button_list[ARow- 1];
                      ACell.Control.Enabled:= True;
                      // display('ok '+ m_c_do_modify_button_list[ARow].Caption);
                    end;
                1 : begin
                      l_field_value:= UserSession.AdoDataset1.Fields[0].AsString;
                      ACell.Text:= l_field_value;
                      // ACell.Text:= System.Copy(l_field_value, 1, 10)+ '...';
                      // m_c_key_list[ARow- 1]:= l_field_value;
                    end;
                2 : begin
                      l_field_value:= UserSession.AdoDataset1.FieldByName('Population').AsString;
                      ACell.Text:= l_field_value;
                    end;
              end; // case AColumn
        end; // draw_in_display_mode

      procedure draw_in_edit_mode;

        procedure display_selected_row;
          var l_field_value: String;
          begin
            case AColumn of
              1 : begin
                    l_field_value:= UserSession.AdoDataset1.Fields[0].AsString;
                    ACell.Control:= m_c_edit_list[0];
                    m_c_edit_list[0].Text:= l_field_value;
                    m_selected_key:= l_field_value;
                  end;
              2 : begin
                    // l_field_value:= UserSession.AdoDataset1.Fields[1].AsString;
                    l_field_value:= UserSession.AdoDataset1.FieldByName('Population').AsString;
                    ACell.Control:= m_c_edit_list[1];
                    m_c_edit_list[1].Text:= l_field_value;
                  end;
              3 : begin
                    ACell.Control:= m_c_do_post_button;
                  end;
              4 : begin
                    ACell.Control:= m_c_do_cancel_button;
                  end;
            end; // case AColumn
          end; // display_selected_row

        procedure display_other_row;
          var l_field_value: String;
          begin
            case AColumn of
              1 : begin
                    l_field_value:= UserSession.AdoDataset1.Fields[0].AsString;
                    // -- do not use all string, to avoid too much scrolling
                    // ACell.Text:= System.Copy(l_field_value, 1, 10)+ '...';
                    ACell.Text:= l_field_value;
                    // m_c_key_list[ARow- 1]:= l_field_value;
                  end;
              2 : begin
                    l_field_value:= UserSession.AdoDataset1.FieldByName('Population').AsString;
                    ACell.Text:= l_field_value;
                  end;
            end; // case AColumn
          end; // display_other_row

        begin // raw_in_edit_mode
          if ARow= 0
            then display_column_title
            else
              if aColumn= 0
                then begin
                    // -- the button column
                    ACell.Control:= m_c_do_modify_button_list[ARow- 1];
                    ACell.Control.Enabled:= False;
                  end
                else
                  if ARow= m_selected_row
                    then display_selected_row
                    else display_other_row;
        end; // draw_in_edit_mode

      begin // IWDBGrid1RenderCell
        // display('> RenderCell '+ Format('row=%3d col=%3d', [ARow, AColumn]));
        if m_do_modify
          then draw_in_edit_mode
          else draw_in_display_mode;
      end; // IWDBGrid1RenderCell

    procedure TIWForm1.handle_do_modify_click(Sender: tObject);
      begin
        with (Sender as tIwButton) do
        begin
          display('ButtonClick '+ Caption+ ' '+ IntToStr(Tag));
          // IwLabel1.Caption:= Caption;
          m_do_modify:= True;
          m_selected_row:= Tag;

          m_c_do_post_button.Visible:= True;
          m_c_do_cancel_button.Visible:= True;
          // IwDbGrid1.Columns[3].Visible:= True;
          // WebApplication.ShowMessage('aha');
        end; // with Sender as tIwButton
      end; // handle_do_modify_click

    procedure TIWForm1.handle_do_post_click(Sender: TObject);
      var l_population: String;
      begin
        clear_display;
        display('post '+ m_selected_key);

        // -- use the data access controls to update the Table
        l_population:= m_c_edit_list[1].Text;

        with UserSession.AdoCommand1 do
        begin
          CommandText:=
              'UPDATE country '
            + '  SET population= '+ l_population
            + '  WHERE Name= '''+ m_selected_key+ '''';
          display('cmd '+ CommandText);
          Execute;
        end; // with UserSession.AdoCommand1


(*
        with UserSession.AdoDataset2 do
        begin
          Open;
          display(' >'+ m_selected_key+ '<');

          if Locate('Name', m_selected_key, [])
            then begin
                display('ok locate');

                Edit;
                FieldByName('Population').AsString:= l_population;
                Post;
              end;
          Close;
        end; // with UserSession.AdoDataset2
*)
        // -- refresh AdoDataset1
        UserSession.AdoDataset1.Close;
        UserSession.AdoDataset1.Open;

        // -- reset the browse mode
        m_do_modify:= False;
        m_c_do_post_button.Visible:= False;
        m_c_do_cancel_button.Visible:= False;
      end; // handle_do_post_click

    procedure TIWForm1.handle_do_cancel_click(Sender: TObject);
      begin
        clear_display;
        display('cancel '+ m_selected_key);

        // -- simply revert to display mode
        m_do_modify:= False;

        // -- reset the browse mode
        m_c_do_post_button.Visible:= False;
        m_c_do_cancel_button.Visible:= False;
      end; // handle_do_cancel_click

initialization
  TIWForm1.SetAsMainForm;

end.
